Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Convert.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Convert.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Convert.cs	(revision 6721)
@@ -31,12 +31,12 @@
   public static class Convert {
     #region Job
-    public static DT.Job ToDto(DB.Job source) {
-      if (source == null) return null;
-      return new DT.Job {
-        Id = source.JobId,
+    public static DT.Task ToDto(DB.Task source) {
+      if (source == null) return null;
+      return new DT.Task {
+        Id = source.TaskId,
         CoresNeeded = source.CoresNeeded,
         ExecutionTime = TimeSpan.FromMilliseconds(source.ExecutionTimeMs),
         MemoryNeeded = source.MemoryNeeded,
-        ParentJobId = source.ParentJobId,
+        ParentTaskId = source.ParentTaskId,
         Priority = source.Priority,
         PluginsNeededIds = (source.RequiredPlugins == null ? new List<Guid>() : source.RequiredPlugins.Select(x => x.PluginId).ToList()),
@@ -44,5 +44,5 @@
         State = Convert.ToDto(source.State),
         StateLog = (source.StateLogs == null ? new List<DT.StateLog>() : source.StateLogs.Select(x => Convert.ToDto(x)).OrderBy(x => x.DateTime).ToList()),
-        IsParentJob = source.IsParentJob,
+        IsParentJob = source.IsParentTask,
         FinishWhenChildJobsFinished = source.FinishWhenChildJobsFinished,
         Command = Convert.ToDto(source.Command),
@@ -53,16 +53,16 @@
     }
 
-    public static DB.Job ToEntity(DT.Job source) {
-      if (source == null) return null;
-      var entity = new DB.Job(); ToEntity(source, entity);
-      return entity;
-    }
-    public static void ToEntity(DT.Job source, DB.Job target) {
-      if ((source != null) && (target != null)) {
-        target.JobId = source.Id;
+    public static DB.Task ToEntity(DT.Task source) {
+      if (source == null) return null;
+      var entity = new DB.Task(); ToEntity(source, entity);
+      return entity;
+    }
+    public static void ToEntity(DT.Task source, DB.Task target) {
+      if ((source != null) && (target != null)) {
+        target.TaskId = source.Id;
         target.CoresNeeded = source.CoresNeeded;
         target.ExecutionTimeMs = source.ExecutionTime.TotalMilliseconds;
         target.MemoryNeeded = source.MemoryNeeded;
-        target.ParentJobId = source.ParentJobId;
+        target.ParentTaskId = source.ParentTaskId;
         target.Priority = source.Priority;
         target.LastHeartbeat = source.LastHeartbeat;
@@ -72,5 +72,5 @@
           target.StateLogs.Add(Convert.ToEntity(sl));
         }
-        target.IsParentJob = source.IsParentJob;
+        target.IsParentTask = source.IsParentJob;
         target.FinishWhenChildJobsFinished = source.FinishWhenChildJobsFinished;
         target.Command = Convert.ToEntity(source.Command);
@@ -83,16 +83,16 @@
 
     #region JobData
-    public static DT.JobData ToDto(DB.JobData source) {
-      if (source == null) return null;
-      return new DT.JobData { JobId = source.JobId, Data = source.Data.ToArray(), LastUpdate = source.LastUpdate };
-    }
-    public static DB.JobData ToEntity(DT.JobData source) {
-      if (source == null) return null;
-      var entity = new DB.JobData(); ToEntity(source, entity);
-      return entity;
-    }
-    public static void ToEntity(DT.JobData source, DB.JobData target) {
-      if ((source != null) && (target != null)) {
-        target.JobId = source.JobId; target.Data = new Binary(source.Data); target.LastUpdate = source.LastUpdate;
+    public static DT.TaskData ToDto(DB.TaskData source) {
+      if (source == null) return null;
+      return new DT.TaskData { TaskId = source.TaskId, Data = source.Data.ToArray(), LastUpdate = source.LastUpdate };
+    }
+    public static DB.TaskData ToEntity(DT.TaskData source) {
+      if (source == null) return null;
+      var entity = new DB.TaskData(); ToEntity(source, entity);
+      return entity;
+    }
+    public static void ToEntity(DT.TaskData source, DB.TaskData target) {
+      if ((source != null) && (target != null)) {
+        target.TaskId = source.TaskId; target.Data = new Binary(source.Data); target.LastUpdate = source.LastUpdate;
       }
     }
@@ -102,5 +102,5 @@
     public static DT.StateLog ToDto(DB.StateLog source) {
       if (source == null) return null;
-      return new DT.StateLog { Id = source.StateLogId, DateTime = source.DateTime, Exception = source.Exception, JobId = source.JobId, SlaveId = source.SlaveId, State = Convert.ToDto(source.State), UserId = source.UserId };
+      return new DT.StateLog { Id = source.StateLogId, DateTime = source.DateTime, Exception = source.Exception, TaskId = source.TaskId, SlaveId = source.SlaveId, State = Convert.ToDto(source.State), UserId = source.UserId };
     }
     public static DB.StateLog ToEntity(DT.StateLog source) {
@@ -111,5 +111,5 @@
     public static void ToEntity(DT.StateLog source, DB.StateLog target) {
       if ((source != null) && (target != null)) {
-        target.StateLogId = source.Id; target.DateTime = source.DateTime; target.Exception = source.Exception; target.JobId = source.JobId; target.SlaveId = source.SlaveId; target.State = Convert.ToEntity(source.State); target.UserId = source.UserId;
+        target.StateLogId = source.Id; target.DateTime = source.DateTime; target.Exception = source.Exception; target.TaskId = source.TaskId; target.SlaveId = source.SlaveId; target.State = Convert.ToEntity(source.State); target.UserId = source.UserId;
       }
     }
@@ -365,45 +365,45 @@
 
 
-    #region JobState
-    public static DT.JobState ToDto(DB.JobState source) {
-      if (source == DB.JobState.Aborted) {
-        return JobState.Aborted;
-      } else if (source == DB.JobState.Calculating) {
-        return JobState.Calculating;
-      } else if (source == DB.JobState.Failed) {
-        return JobState.Failed;
-      } else if (source == DB.JobState.Finished) {
-        return JobState.Finished;
-      } else if (source == DB.JobState.Offline) {
-        return JobState.Offline;
-      } else if (source == DB.JobState.Paused) {
-        return JobState.Paused;
-      } else if (source == DB.JobState.Transferring) {
-        return JobState.Transferring;
-      } else if (source == DB.JobState.Waiting) {
-        return JobState.Waiting;
-      } else
-        return JobState.Failed;
-    }
-
-    public static DB.JobState ToEntity(DT.JobState source) {
-      if (source == DT.JobState.Aborted) {
-        return DB.JobState.Aborted;
-      } else if (source == DT.JobState.Calculating) {
-        return DB.JobState.Calculating;
-      } else if (source == DT.JobState.Failed) {
-        return DB.JobState.Failed;
-      } else if (source == DT.JobState.Finished) {
-        return DB.JobState.Finished;
-      } else if (source == DT.JobState.Offline) {
-        return DB.JobState.Offline;
-      } else if (source == DT.JobState.Paused) {
-        return DB.JobState.Paused;
-      } else if (source == DT.JobState.Transferring) {
-        return DB.JobState.Transferring;
-      } else if (source == DT.JobState.Waiting) {
-        return DB.JobState.Waiting;
-      } else
-        return DB.JobState.Failed;
+    #region TaskData
+    public static DT.TaskState ToDto(DB.TaskState source) {
+      if (source == DB.TaskState.Aborted) {
+        return TaskState.Aborted;
+      } else if (source == DB.TaskState.Calculating) {
+        return TaskState.Calculating;
+      } else if (source == DB.TaskState.Failed) {
+        return TaskState.Failed;
+      } else if (source == DB.TaskState.Finished) {
+        return TaskState.Finished;
+      } else if (source == DB.TaskState.Offline) {
+        return TaskState.Offline;
+      } else if (source == DB.TaskState.Paused) {
+        return TaskState.Paused;
+      } else if (source == DB.TaskState.Transferring) {
+        return TaskState.Transferring;
+      } else if (source == DB.TaskState.Waiting) {
+        return TaskState.Waiting;
+      } else
+        return TaskState.Failed;
+    }
+
+    public static DB.TaskState ToEntity(DT.TaskState source) {
+      if (source == DT.TaskState.Aborted) {
+        return DB.TaskState.Aborted;
+      } else if (source == DT.TaskState.Calculating) {
+        return DB.TaskState.Calculating;
+      } else if (source == DT.TaskState.Failed) {
+        return DB.TaskState.Failed;
+      } else if (source == DT.TaskState.Finished) {
+        return DB.TaskState.Finished;
+      } else if (source == DT.TaskState.Offline) {
+        return DB.TaskState.Offline;
+      } else if (source == DT.TaskState.Paused) {
+        return DB.TaskState.Paused;
+      } else if (source == DT.TaskState.Transferring) {
+        return DB.TaskState.Transferring;
+      } else if (source == DT.TaskState.Waiting) {
+        return DB.TaskState.Waiting;
+      } else
+        return DB.TaskState.Failed;
     }
     #endregion
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/LightweightTask.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/LightweightTask.cs	(revision 6721)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/LightweightTask.cs	(revision 6721)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.Hive.DataTransfer {
+  [DataContract]
+  [Serializable]
+  public class LightweightTask : HiveItem {
+    [DataMember]
+    public TimeSpan ExecutionTime { get; set; }
+    [DataMember]
+    public Guid? ParentTaskId { get; set; }
+    [DataMember]
+    public List<StateLog> StateLog { get; set; }
+    [DataMember]
+    public TaskState State { get; set; }
+    [DataMember]
+    public Command? Command { get; set; }
+    [DataMember]
+    public DateTime LastJobDataUpdate { get; set; }
+
+    public StateLog CurrentStateLog { get { return StateLog.LastOrDefault(); } }
+    public DateTime? DateCreated { get { return StateLog.Count > 0 ? new DateTime?(StateLog.First().DateTime) : null; } }
+    public DateTime? DateFinished { get { return (StateLog.Count > 0 && CurrentStateLog.State == TaskState.Finished) ? new DateTime?(CurrentStateLog.DateTime) : null; } }
+
+    public LightweightTask() {
+      StateLog = new List<DataTransfer.StateLog>();
+    }
+
+    public LightweightTask(Task job) {
+      this.Id = job.Id;
+      this.ExecutionTime = job.ExecutionTime;
+      this.ParentTaskId = job.ParentTaskId;
+      this.StateLog = new List<StateLog>(job.StateLog);
+      this.State = job.State;
+      this.Command = job.Command;
+      this.LastJobDataUpdate = job.LastJobDataUpdate;
+    }
+  }
+}
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/StateLog.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/StateLog.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/StateLog.cs	(revision 6721)
@@ -36,7 +36,7 @@
     public string Exception { get; set; }
     [DataMember]
-    public JobState State { get; set; }
+    public TaskState State { get; set; }
     [DataMember]
-    public Guid JobId { get; set; }
+    public Guid TaskId { get; set; }
 
     public StateLog() { }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/Task.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/Task.cs	(revision 6721)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/Task.cs	(revision 6721)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.Hive.DataTransfer {
+  [DataContract]
+  [Serializable]
+  public class Task : LightweightTask {
+    [DataMember]
+    public int Priority { get; set; }
+    [DataMember]
+    public int CoresNeeded { get; set; }
+    [DataMember]
+    public int MemoryNeeded { get; set; }
+    [DataMember]
+    public List<Guid> PluginsNeededIds { get; set; }
+    [DataMember]
+    public DateTime? LastHeartbeat { get; set; }
+    [DataMember]
+    public bool IsParentJob { get; set; }
+    [DataMember]
+    public bool FinishWhenChildJobsFinished { get; set; }
+    [DataMember]
+    public Guid HiveExperimentId { get; set; }
+    [DataMember]
+    public bool IsPrivileged { get; set; }
+
+    public Task() {
+      this.PluginsNeededIds = new List<Guid>();
+    }
+  }
+}
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/TaskData.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/TaskData.cs	(revision 6721)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/TaskData.cs	(revision 6721)
@@ -0,0 +1,38 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.Hive.DataTransfer {
+  [DataContract]
+  [Serializable]
+  public class TaskData {
+    [DataMember]
+    public Guid TaskId { get; set; }
+    [DataMember]
+    public byte[] Data { get; set; }
+    [DataMember]
+    public DateTime LastUpdate { get; set; }
+
+    public TaskData() { }
+  }
+}
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/TaskState.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/TaskState.cs	(revision 6721)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/TaskState.cs	(revision 6721)
@@ -0,0 +1,92 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Services.Hive.DataTransfer {
+  [Serializable]
+  public enum TaskState {
+    /// <summary>
+    /// A task is offline as long as he is not yet submitted to the hive
+    /// </summary>
+    Offline,
+
+    /// <summary>
+    /// Task is waiting to be calculated
+    /// </summary>
+    Waiting,
+
+    /// <summary>
+    /// Task is beeing transferred
+    /// </summary>
+    Transferring,
+
+    /// <summary>
+    /// Task is actively calculated on a Slave
+    /// </summary>
+    Calculating,
+
+    /// <summary>
+    /// Task is paused, will not be picked up by slaves
+    /// </summary>
+    Paused,
+
+    /// <summary>
+    /// Task as finished and is ready to be collected by the Client
+    /// </summary>
+    Finished,
+
+    /// <summary>
+    /// Task is aborted and result can be collected by the Client
+    /// </summary>
+    Aborted,
+
+    /// <summary>
+    /// Task as been aborted due to an error. Results are ready to be collected
+    /// </summary>
+    Failed
+  };
+
+  public static class TaskStateExtensions {
+    /// <summary>
+    /// This job is not yet done
+    /// </summary>
+    public static bool IsActive(this TaskState taskState) {
+      return !taskState.IsDone();
+    }
+
+    /// <summary>
+    /// This job is Waiting
+    /// </summary>
+    public static bool IsWaiting(this TaskState taskState) {
+      return taskState == TaskState.Waiting;
+    }
+
+    /// <summary>
+    /// This job is Finished || Failed || Aborted
+    /// </summary>
+    public static bool IsDone(this TaskState taskState) {
+      return taskState == TaskState.Finished ||
+        taskState == TaskState.Aborted ||
+        taskState == TaskState.Failed;
+    }
+  }
+}
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/HeuristicLab.Services.Hive-3.3.csproj
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/HeuristicLab.Services.Hive-3.3.csproj	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/HeuristicLab.Services.Hive-3.3.csproj	(revision 6721)
@@ -111,8 +111,8 @@
     <Compile Include="DataTransfer\HiveExperimentPermission.cs" />
     <Compile Include="DataTransfer\HiveItem.cs" />
-    <Compile Include="DataTransfer\Job.cs" />
-    <Compile Include="DataTransfer\JobData.cs" />
-    <Compile Include="DataTransfer\JobState.cs" />
-    <Compile Include="DataTransfer\LightweightJob.cs" />
+    <Compile Include="DataTransfer\Task.cs" />
+    <Compile Include="DataTransfer\TaskData.cs" />
+    <Compile Include="DataTransfer\TaskState.cs" />
+    <Compile Include="DataTransfer\LightweightTask.cs" />
     <Compile Include="DataTransfer\NamedHiveItem.cs" />
     <Compile Include="DataTransfer\Permission.cs" />
